package cn.iocoder.hake.module.agent.service.agent;

import java.util.*;
import javax.validation.*;
import cn.iocoder.hake.module.agent.controller.admin.agent.vo.*;
import cn.iocoder.hake.module.agent.dal.dataobject.agent.AgentDO;
import cn.iocoder.hake.framework.common.pojo.PageResult;

/**
 * 代理商管理 Service 接口
 *
 * @author hake
 */
public interface AgentService {

    /**
     * 创建代理商管理
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createAgent(@Valid AgentSaveReqVO createReqVO);

    /**
     * 代理商审核
     * @return
     */
    Long  updateAgentStatus(@Valid AuditRespVO auditRespVO);

    /**
     * 更新代理商管理
     *
     * @param updateReqVO 更新信息
     */
    void updateAgent(@Valid AgentSaveReqVO updateReqVO);

    /**
     * 删除代理商管理
     *
     * @param id 编号
     */
    void deleteAgent(Long id);

    /**
    * 批量删除代理商管理
    *
    * @param ids 编号
    */
    void deleteAgentListByIds(List<Long> ids);

    /**
     * 获得代理商管理
     *
     * @param id 编号
     * @return 代理商管理
     */
    AgentDO getAgent(Long id);

    /**
     * 获得代理商管理分页
     *
     * @param pageReqVO 分页查询
     * @return 代理商管理分页
     */
    PageResult<AgentDO> getAgentPage(AgentPageReqVO pageReqVO);

}